
# Makefile for PIC 16C84 utility programs
# Copyright (C) 1995-6 James Cleverdon
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Address:
#	James Cleverdon
#	16465 S.W. Estuary Dr. # 101
#	Beaverton, OR 97006-7954, USA
#
#	jamesc@sequent.com
#
# $Log:	Makefile.gnu,v $
Revision 1.0  96/01/24  23:55:18  jamesc
Initial revision

#
# $Id: Makefile.gnu,v 1.0 96/01/24 23:55:18 jamesc Exp Locker: jamesc $

# The following program variables may have to be changed depending on which
# one you are using, and whether it is on your PATH or not.
#
#CC=	cc
CC=	gcc

#FLEX=	lex		# FreeBSD may call flex "lex"
FLEX=	flex

#YACC=	yacc
#YACC=	byacc
YACC=	bison

# Uncomment the "-g" version of CFLAGS to include debugger information.
# (Your gdb may be happier with different flags.)
#
#CFLAGS= -g -DNO_BZERO=1
#CFLAGS= -O			# Use this line if bzero is provided
CFLAGS= -O -DNO_BZERO=1

# Add any needed libraries to LIBS.  This shouldn't be necessary
#
LIBS=

# Add any loader flags to LDFLAGS.
#
#LDFLAGS= -s
LDFLAGS=

OBJS=	gram.o lex.o code.o emitter.o

now:	dis_c84 asm_c84 test.hex wl_mine.hex

asm_c84:	$(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(OBJS) -o asm_c84 $(LIBS)

dis_c84:	dis_c84.c c84_mem.h
	$(CC) $(CFLAGS) $(LDFLAGS) dis_c84.c -o dis_c84 $(LIBS)

lex.c:	lex.l
	$(FLEX) -ipv lex.l
	mv lex.yy.c lex.c

lex.o:	lex.c x.tab.h c84.h c84_ext.h

# The gram.c rule below is set up for bison.  For yacc, comment out the
# "gram.tab.c" line and uncomment the "y.tab.c" line.  Same for the
# "gram.tab.h" and "y.tab.h" lines, respectively.

gram.c:	gram.y
	$(YACC) -dtv gram.y
#	mv y.tab.c gram.c
	mv gram.tab.c gram.c
#	if cmp -s y.tab.h x.tab.h ; then : ; else cp y.tab.h x.tab.h ; fi
	if cmp -s gram.tab.h x.tab.h ; then : ; else cp gram.tab.h x.tab.h ; fi

gram.o: gram.c c84.h c84_ext.h

code.o:	code.c c84.h c84_ext.h c84_mem.h

emitter.o:	emitter.c c84_ext.h

test.hex:	test.a84 asm_c84 dis_c84
	asm_c84 test.a84
	dis_c84 test.hex > test.dis

wl_mine.hex:	wl_mine.a84 asm_c84 dis_c84
	asm_c84 wl_mine.a84
	dis_c84 wl_mine.hex > wl_mine.dis
