#ifndef _C84_EXT_H_
#define _C84_EXT_H_		/* avoid multiple includes */

/*
 * c84_ext.h -- PIC 16C84 external declarations,
 *		CSE510 Project, Fall 1995
 *
 * Copyright (C) 1995-6 James Cleverdon
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Address:
 *	James Cleverdon
 *	16465 S.W. Estuary Dr. # 101
 *	Beaverton, OR 97006-7954, USA
 *
 *	jamesc@sequent.com
 *
 * $Log:	c84_ext.h,v $
 * Revision 1.1  96/01/03  11:45:01  jamesc
 * Removed line_buf[] and added list_head/list_tail
 * NODE ptrs for listing support.
 * 
 * Revision 1.0  1995/12/19 01:28:34  jamesc
 * "CSE510_project"
 *
 */

#ident "$Id: c84_ext.h,v 1.1 96/01/03 11:45:01 jamesc Exp Locker: jamesc $"

#ifndef _C84_H
#include "c84.h"
#endif

extern YYSTYPE	yylval;
extern int	yyleng;
extern char	*yytext;

extern long	line_num;
extern int	col;
extern char	*this_file;			/* current input file	*/
extern NODE	*list_head;
extern NODE	*list_tail;

extern NODEP	bin_op(NODEP, NODEP, NODEP);
extern NODEP	c_bit(NODEP, NODEP, NODEP);
extern NODEP	c_dbyte(NODEP, NODEP, NODEP);
extern NODEP	c_dol(NODEP);
extern NODEP	c_dorg(NODEP, NODEP, NODEP);
extern NODEP	c_dword(NODEP, NODEP, NODEP);
extern NODEP	c_ebyte(NODEP, NODEP);
extern NODEP	c_eorg(NODEP, NODEP, NODEP);
extern NODEP	c_equ(NODEP, NODEP, NODEP);
extern NODEP	c_eword(NODEP, NODEP);
extern NODEP	c_f_b(NODEP, NODEP, NODEP);
extern NODEP	c_f_d(NODEP, NODEP, NODEP);
extern NODEP	c_fill(NODEP, NODEP, NODEP, NODEP, NODEP);
extern NODEP	c_fuse(NODEP, NODEP);
extern NODEP	c_gen_op(NODEP, NODEP);
extern NODEP	c_id(NODEP);
extern NODEP	c_org(NODEP, NODEP, NODEP);
extern NODEP	c_page(NODEP, NODEP);
extern NODEP	c_res(NODEP, NODEP, NODEP);
extern NODEP	c_retlw(NODEP, NODEP);
extern NODEP	c_unequ(NODEP, NODEP);
extern NODEP	comma_list(NODEP, NODEP, NODEP);
extern NODEP	eval(NODEP np);
extern NODEP	label_scan(char *);
extern NODEP	new_node(int tok);
extern NODEP	un_op(NODEP, NODEP);
extern char	*prtable_char(uint);
extern int	char_const(char *str);
extern int	const_n(char *str, int base);
extern int	end_string_const(void);
extern int	esc_const(char *str);
extern int	new_code(int tok, int opcode);
extern int	new_tok(int tok);
extern void	*alloc(int size, char *msg);
extern void	begin_string_const(void);
extern void	err(char *fmt, ...);
extern void	free_node(NODEP);
extern void	i8_addr(ulong a);
extern void	i8_byte(int b);
extern void	i8_close(void);
extern void	i8_open(char *file);
extern void	i8_word(int w);
extern void	label_def(NODEP, long val, int type);
extern void	more_string_const(void);
extern void	nerr(NODEP, char *fmt, ...);

extern int	yylex(void);
extern int	yyparse(void);
extern void	yyerror(char *msg);

#endif /* _C84_EXT_H_ */
